// File DYNFFSYS.CPP Dynamical System Feedforward Network
//               Turbo Vision interface

extern "C" {
   #include "dyn.h"
   #include "ff.h"
   }

#include "dynsetup.cpp"

void handle_system (system_response *control_flag)
  {
   tdynsetapp *Setup_App = new tdynsetapp();
   quit_flag = quit;
   if (*control_flag == startup) {
      g_ff_setup.error_threshold = 0.001;
      g_ff_setup.no_of_inputs = 2;
      g_ff_setup.no_of_h1_nodes = 12;
      g_ff_setup.no_of_outputs = 2;
      g_ff_setup.sigmoid_out = TRUE;
      g_ff_setup.norm_out_min = 0.1;
      }
   Setup_App->run();
   Setup_App->destroy (Setup_App);
   *control_flag = quit_flag;
   return;
   }

int main()
   {
   system_response prog_control = startup;
   initialize_ff_setup (&g_ff_setup);
   initialize_dyn_setup (&g_dyn_setup);
   strcpy (system_name,"Dynamical System");
   display_startup_message();
   do
   {
   handle_system(&prog_control);
   switch (prog_control) {
   case train_net:
	train_network_from_data (g_ff_setup,
	     &backpropagation_training);
	break;
   case training_data:
	create_training_file (g_ff_setup,g_dyn_setup);
	break;
   case run_net:
	run_dynamic_network (g_ff_setup,g_dyn_setup);
	break;
   case special:
	run_dynam_sys (g_dyn_setup);
	break;
   }
   } while (prog_control != quit);
   return 0;
   } // end main