// File FFADVSET.CPP Set up Turbo Vision interface for
//      Advanced Feedforward Network Training
//      (genetic algorithm, simulated annealing, conjugate gradient)

#ifndef FFADVSET_CPP
#define FFADVSET_CPP

#include "ffsetup.cpp"
#include "gacoll.cpp"

const cmTrain2 = 250,
      cmTrain3 = 251,
      cmTrain4 = 252;

TMenuItem *train2_item,
	  *train3_item,
	  *train4_item;

class tadvsetapp : public tffsetapp
   {
   public :
     tadvsetapp();
     virtual void training_setup();
     virtual void handleEvent (TEvent& event);
     static TMenuBar *initMenuBar (TRect r );
     static void init_submenus();
   };

tadvsetapp::tadvsetapp() : tffsetapp(),
   TProgInit (&tadvsetapp::initStatusLine,
	      &tadvsetapp::initMenuBar,
	      &tadvsetapp::initDeskTop
	      )
   {
   ((tcolor_data_obj *) (system_setup_data.item_collection)->
	 at(set_data_file_name - 1))->disable();
   ((tcolor_data_obj *) (system_setup_data.item_collection)->
	 at(set_new_data_file_name - 1))->disable();
   ga_setup_to_collection (&ga_setup_rec,training_setup_data.item_collection);
   return;
   }

 void tadvsetapp::init_submenus()
   {
   tffsetapp::init_submenus();
   // Skip data submenus:
   train_submenu->next = special_submenu;
   // Skip training setup items:
   train_submenu->subMenu->items = setup_trn_item;
   train_submenu->subMenu->deflt = train_item;
   // Add alternative training items:
   train4_item = new TMenuItem ("Train Network (CG)",cmTrain4,kbNoKey,
	 hcNoContext,0,0);
   train3_item = new TMenuItem ("Train Network (SA)",cmTrain3,
	 kbNoKey,hcNoContext,0,train4_item);
   train2_item = new TMenuItem ("Train Network (~G~A)",cmTrain2,
	 kbNoKey,hcNoContext,0,train3_item);
   train_item->next = train2_item;
   return;
   }

TMenuBar *tadvsetapp::initMenuBar ( TRect r )
{
   r.b.y = r.a.y + 1;  //Set bottom line 1 line below top line
   init_submenus();
   return new TMenuBar (r,new TMenu(*about_submenu));
 }

void tadvsetapp::handleEvent (TEvent& event)
 {
    tffsetapp::handleEvent(event);
    if (event.what == evCommand) {
       switch (event.message.command) {
	  case cmTrain2:
	     quit_flag = train2_net;
	     TApplication::endModal(cmQuit); // End Application
	     break;
	  case cmTrain3:
	     quit_flag = train3_net;
	     TApplication::endModal(cmQuit); // End Application
	     break;
	  case cmTrain4:
	     quit_flag = train4_net;
	     TApplication::endModal(cmQuit); // End Application
	     break;
	  default:
	     return;
	  }  // end switch
	  clearEvent(event);
	  }  // end if
     return;
     } // end proc

void tadvsetapp::training_setup()
   {
   list_dialog ("SETUP PARAMETERS","",&training_setup_data,
     MAX_NO_OF_SETUP_ITEMS,&standard_processing);
   return;
   }

#endif