// File FFINSYS.CPP NN Financial Forecasting System

#include <alloc.h>

extern "C" {
   #include "ffin.h"
   }

#include "ffinsetp.cpp"

void handle_system (system_response *control_flag) {
   tffinsetapp *Setup_App = new tffinsetapp();
   short i,j,k;
   quit_flag = quit;
   Setup_App->run();
   Setup_App->destroy (Setup_App);
   *control_flag = quit_flag;
   return;
   }

int main()
   {
   system_response prog_control = startup;
   initialize_ff_setup (&g_ff_setup);
   g_ff_setup.no_of_inputs = 5;
   g_ff_setup.no_of_h1_nodes = 10;
   g_ff_setup.no_of_outputs = 1;
   initialize_ffin_training_rec (g_ff_setup,&g_ffin_tr_setup);
   strcpy (system_name,"Financial Forecasting");
   display_startup_message();
   do
   {
   handle_system(&prog_control);
   switch (prog_control) {
   case run_net:
	run_ffin_network (g_ff_setup);
	break;
   case train_net:
	train_network_from_data (g_ff_setup,
	     &backpropagation_training);
	break;
   case training_data:
	create_training_file (g_ff_setup,g_ffin_tr_setup);
	break;
	}
   } while (prog_control != quit);
   return 0;
   } // end main
